#_ SCLibCpp.make  
# Copyright (C} 1990-1993 by Symantec Corporation
# All Rights Reserved
#	for C++ compiler

# To recreate library execute
# Build SCLibCpp

# NOTE: If you wish to change the library, copy the folder and change
#	the values for ROOT, CLIB and O.  That way future Symantec releases
#	will not destroy your changes.

ROOT	=	{SCLibraries}
CPPLIB	=	{ROOT}SCSrcLibCpp:
O		=	{ROOT}SCSrcLibCpp:SCObj:

CPP		=	SCpp
COptions=	-r -O all
BLDTARG	=	SCLibCpp
A		=	asm
AOptions=	-case on

# Directory Dependancies
{O}		{CPPLIB}

OBJ1= {O}_new.cpp.o {O}vector.cpp.o {O}_delete.cpp.o {O}_handler.cpp.o {O}vecnew.cpp.o
COMPLEX= {O}complex.cpp.o {O}coperat.cpp.o {O}cstrm.cpp.o {O}ctrig.cpp.o
PAS = {O}PGM1.a.o {O}PasObj.a.o

# Streams Library
IO=	{O}iosfb.cpp.o 
	{O}iosfs.cpp.o 
	{O}iosios.cpp.o 
	{O}iosiost.cpp.o 
	{O}iosiowa.cpp.o 
	{O}iosis.cpp.o 
	{O}iosis2c.cpp.o 
	{O}iosisflt.cpp.o 
	{O}iosiwa.cpp.o 
	{O}iosman.cpp.o 
	{O}iosos.cpp.o 
	{O}iosos2c.cpp.o 
	{O}iosowa.cpp.o 
	{O}iossb.cpp.o 
	{O}iossti.cpp.o 
	{O}iosstd.cpp.o 
	{O}strsbuf.cpp.o 
	{O}strstrm.cpp.o 
	{O}stdiobuf.cpp.o

{BLDTARG}  {OBJ1} {COMPLEX} {PAS} {IO} SCLibCpp.make
	Lib {OBJ1} {COMPLEX} {PAS} -o SCLibCpp.o
	Lib {IO} -o SCstreamsIO.o
	Move SCLibCpp.o {SCLibraries}
	Move SCstreamsIO.o {SCLibraries}

{O}_new.cpp.o  _new.cpp
	{CPP} {COptions} -s SCPP -o {O} _new.cpp
	
{O}vector.cpp.o  vector.cpp
	{CPP} {COptions} -s SCPP  -o {O} vector.cpp
	
{O}_delete.cpp.o  _delete.cpp
	{CPP} {COptions} -s SCPP  -o {O} _delete.cpp
	
{O}_handler.cpp.o  _handler.cpp
	{CPP} {COptions} -s SCPP  -o {O} _handler.cpp
	
{O}vecnew.cpp.o  vecnew.cpp
	{CPP} {COptions} -s SCPP  -o {O} vecnew.cpp
	
{O}PGM1.a.o  PGM1.a
	{A} {AOptions} -o {O} PGM1.a
	
{O}PasObj.a.o  PasObj.a
	{A} {AOptions}  -o {O} PasObj.a
	
{O}complex.cpp.o  complex.cpp "{SCIncLUDES}"complex.h
	{CPP} {COptions} -s SCCOMPLEX -o {O} complex.cpp
	
{O}coperat.cpp.o  coperat.cpp "{SCIncLUDES}"complex.h
	{CPP} {COptions}  -s SCCOMPLEX -o {O} coperat.cpp
	
{O}cstrm.cpp.o  cstrm.cpp "{SCIncLUDES}"complex.h
	{CPP} {COptions}  -s SCCOMPLEX -o {O} cstrm.cpp
	
{O}ctrig.cpp.o  ctrig.cpp "{SCIncLUDES}"complex.h
	{CPP} {COptions}  -s SCCOMPLEX -o {O} ctrig.cpp
	
#IOStreams
IOSMacDefs  IOSMacDefs.h
	{CPP} IOSMacDefs.h -dumpc IOSMacDefs -o scrapIOSMD
	delete scrapIOSMD
{O}iosfb.cpp.o  IOSMacDefs iosfb.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosfb.cpp.o iosfb.cpp
{O}iosfs.cpp.o  IOSMacDefs iosfs.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosfs.cpp.o iosfs.cpp
{O}iosios.cpp.o  IOSMacDefs iosios.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosios.cpp.o iosios.cpp
{O}iosiost.cpp.o  IOSMacDefs iosiost.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosiost.cpp.o iosiost.cpp
{O}iosiowa.cpp.o  IOSMacDefs iosiowa.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosiowa.cpp.o iosiowa.cpp
{O}iosis.cpp.o  IOSMacDefs iosis.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosis.cpp.o iosis.cpp
{O}iosis2c.cpp.o  IOSMacDefs iosis2c.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosis2c.cpp.o iosis2c.cpp
{O}iosisflt.cpp.o  IOSMacDefs iosisflt.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosisflt.cpp.o iosisflt.cpp
{O}iosiwa.cpp.o  IOSMacDefs iosiwa.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosiwa.cpp.o iosiwa.cpp
{O}iosman.cpp.o  IOSMacDefs iosman.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosman.cpp.o iosman.cpp
{O}iosos.cpp.o  IOSMacDefs iosos.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosos.cpp.o iosos.cpp
{O}iosos2c.cpp.o  IOSMacDefs iosos2c.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosos2c.cpp.o iosos2c.cpp
{O}iosowa.cpp.o  IOSMacDefs iosowa.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosowa.cpp.o iosowa.cpp
{O}iossb.cpp.o  IOSMacDefs iossb.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iossb.cpp.o iossb.cpp
{O}iossti.cpp.o  IOSMacDefs iossti.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iossti.cpp.o iossti.cpp
{O}iosstd.cpp.o  IOSMacDefs iosstd.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}iosstd.cpp.o iosstd.cpp
{O}strsbuf.cpp.o  IOSMacDefs strsbuf.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}strsbuf.cpp.o strsbuf.cpp
{O}strstrm.cpp.o  IOSMacDefs strstrm.cpp
	{CPP} {COptions} -load IOSMacDefs -s SCSTREAM -o {O}strstrm.cpp.o strstrm.cpp
{O}stdiobuf.cpp.o  stdiobuf.cpp
	{CPP} {COptions} -s SCSTREAM -o {O}stdiobuf.cpp.o stdiobuf.cpp

